% Przyklad 4.4.A:
% m-plik: przyklad_4_4_A.m
%
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./KD.

close all, clear all, clc
FontName   = 'Times New Roman';
FontSize   = 24;
Resolution = 600;

M = 10
N = 2*M+1
Omp = [0         0.45*pi ]; %pasmo przepustowe
Oms = [0.55*pi   pi      ]; %pasmo zaporowe
Omc = (Omp(2)+Oms(1))/2;
Wp = 1; 
Ws = 100;
%% 1. MSE
h_1 = fir_mse(M,Omc);
%% 2. MSE wazony
Wp1 = 1; 
Ws1 = 175;
h_2=fir_mse_W(M,Omc,Wp1,Ws1);
%% 3. MIN-MAX  M=[10]
Wp2=1;
Ws2=10;
h_3=fir_min_max(M,Omp,Oms,Wp2,Ws2);
%% Ch-ki amplitudowe
[Hw_1, w_1] = freqz(h_1,1);
[Hw_2, w_2] = freqz(h_2,1);
[Hw_3, w_3] = freqz(h_3,1);    
    
kreska=['-k';'-b';'-r'];    
FontSize   = 16;
figure, hold on  
subplot(2,1,1), hold on               
    plot(w_1, 20*log10(abs(Hw_1)), kreska(1,:),'LineWidth',1)    
    plot(w_2, 20*log10(abs(Hw_2)), kreska(2,:),'LineWidth',1)    
    plot(w_3, 20*log10(abs(Hw_3)), kreska(3,:),'LineWidth',1)    
    %legend('MS','MSW','MinMax')
    title(['N=' num2str(N)],'FontSize',FontSize,'FontName',FontName)
    xlabel('\Omega (rad)','FontSize',FontSize,'FontName',FontName)
    ylabel('|H(\Omega)| (dB)','FontSize',FontSize,'FontName',FontName)
    axis tight, box on, grid on   
    v=axis; axis([v(1) 2 -2 2])
    set(gca,'FontSize',FontSize,'FontName',FontName)    
subplot(2,1,2), hold on               
    plot(w_1, 20*log10(abs(Hw_1)), kreska(1,:),'LineWidth',1)    
    plot(w_2, 20*log10(abs(Hw_2)), kreska(2,:),'LineWidth',1)    
    plot(w_3, 20*log10(abs(Hw_3)), kreska(3,:),'LineWidth',1)        
    legend('MS','MSW','MM','Location','SouthWest')
    title(['N=' num2str(N)],'FontSize',FontSize,'FontName',FontName)
    xlabel('\Omega (rad)','FontSize',FontSize,'FontName',FontName)
    ylabel('|H(\Omega)| (dB)','FontSize',FontSize,'FontName',FontName)
    axis tight, box on, grid on
    v=axis; axis([v(1) v(2) -60 5])
    set(gca,'FontSize',FontSize,'FontName',FontName)

% KONIEC PRZYKLADU 4.4.A;