% Przyklad 4.6:
% m-plik: przyklad_4_6.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.


clc; clear; close all;

M=10; n=0:M; K=32;            % rzad filtra , indeksy h[n] oraz krotnosc nadprobkowania;
dd=1/K;                       % ulamkowy krok opoznienia w dziedzinie indeksow;
k=0;                          % uruchamiamy licznik petli;
for d=0:dd:1-dd; k=k+1;       % poczatek petli oraz zwiekszenie licznika "k" w kazdym obiegu;
    hh(k,:)=sinc(n-M/2+d);    % w wierszach macierzy hh umieszczamy kolejne odp. impulsowe;
    h0(k:K:K*(M+1))=hh(k,:);  % te same odp. impulsowe ukladamy naprzemiennie w h0[n];
end;

N=2^8; x=rand(1,N);           % to jest dyskretny "dowolny sygnal";
for k=1:K,
    y1(k:K:K*N)=filter(hh(k,:),1,x); % wyliczamy poprzesuwane wyniki filtracji 
                                     % (patrz rys.4.42),
                                     % ukladajac probki naprzemiennie w ciagu wynikowym;
end;

% sposob alternatywny:
x2=zeros(1,K*N); x2(1:K:K*N)=x;      % ciag x2, to nadprobkowany K-krotnie sygnal x;
y2=filter(h0,1,x2);                  % wyznaczamy wynik filtracji za pomoca h0;
err=max(abs(y1(:)-y2(:))),           % porownanie, czy to na pewno to samo;

    figure(1);
        subplot(2,1,1);
            plot(y1,'r.-');  grid on;  hold on;
            plot(y2,'bo-');
                title('Warto ten wykres rozciagnac');
                legend('sygnal y1','sygnal y2');  xlabel('n');
        subplot(2,1,2);
            plot(h0,'ko-');  grid on;
                legend('odp.imp. h0[n]');  xlabel('n');
    figure(2);
            mesh(hh);   axis tight;
                title('wszystkie odpowiedzi impulsowe razem');  xlabel('indeks n'); ylabel('numer odpowiedzi imp.');
        
% KONIEC PRZYKLADU 4.6.