% Przyklad 4.9: 
% m-plik: przyklad_4_9.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 4. Projektowanie filtrow. 
% Autorzy rozdzialu: Krzysztof Duda, Przemyslaw Korohoda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all;          % przygotowanie "biurka" do pracy;
Fg=0.01; Fz=0.012;              % czestotliwosci graniczne filtra;
A_dB=60;                        % tlumienie w pasmie zaporowym w dB;
NF=100000;                      % liczba punktow na osi F do wylicz. ch-k;
M=20; p=2*pi/(3*M); r=127/128;  % parametry ktore warto zmieniac;

Nref=round(A_dB/(22*(Fz-Fg))),  % wyliczamy rzad filtra "ref";
Wref=[1,10];                    % wagi dla procedury "remez";
Aref=[1,1,0,0];                 % amplitudy docelowe dla funkcji "remez";
Fref=[0,Fg,Fz,0.5]*2;           % wektor czestotl. dla funkcji "remez";
href=remez(Nref,Fref,Aref,Wref);% wyznaczamy odpowiedz imp. filtra "ref";
[Href,W]=freqz(href,1,NF); F=W/(2*pi); % wyliczamy ch-ki filtra "ref";

Fprot=[0,Fg*M,Fz*M,0.5]*2;      % wektor czestotl. dla funkcji "remez";
Nprot=floor(Nref/M),            % wyliczamy rzad filtra "prot";
hprot=remez(Nprot,Fprot,Aref,Wref); % wyznaczamy odp. imp. filtra "prot";

hnp=zeros(1,M*Nprot+1); hnp(1:M:end)=hprot; % nadprobkowanie;
Hnp=freqz(hnp,1,NF);            % ch-ki filtra po nadprobkowaniu (F=Fref);

A=1+2*cos(M*p); B=1+2*cos(p);   % a1 i b1 opisuja Hintrp1(z);
b1=[1,zeros(1,M-1),-r^M*A,zeros(1,M-1),r^(2*M)*A,zeros(1,M-1),-r^(3*M)*1];
a1=[1,-r*B,r^2*B,-r^3*1];
Hintrp1=freqz(b1,a1,NF);

C=2*cos(M*p/2); D=2*cos(p/2);   % a2 i b2 opisuja Hintrp2(z);
b2=[1,zeros(1,M-1),-r^M*C,zeros(1,M-1),r^(2*M)*1];
a2=[1,-r*D,r^2*1];
Hintrp2=freqz(b2,a2,NF);

E=5.2;                          % te wartosc dobieramy recznie;
hkor=[1,zeros(1,M-1),-E,zeros(1,M-1),1]; % odp. impulsowa filtra FIR korygujacego;
Hkor=freqz(hkor,1,NF);

H_IFIR=Hnp.*Hintrp1.*Hintrp2.*Hkor; % efekt zastepczy filtracji;

        figure(1);
            subplot(4,1,1);
                    plot(F,abs(Hnp),'b.-');     grid on;; hold on;
                          xlim([0,0.012]);  legend('DTFT: modul(H_n_p)',0);
            subplot(4,1,2);
                    plot(F,abs(Hintrp1),'b.-'); grid on;; hold on;
                          xlim([0,0.012]);  legend('DTFT: modul(H_i_n_t_r_p_1)',0);
            subplot(4,1,3);
                    plot(F,abs(Hintrp2),'b.-'); grid on;; hold on;
                          xlim([0,0.012]);  legend('DTFT: modul(H_i_n_t_r_p_2)',0);
            subplot(4,1,4);
                    plot(F,abs(Hkor),'b.-');    grid on;; hold on;
                          xlim([0,0.012]);  legend('DTFT: modul(H_k_o_r)',0);
                          xlabel('F');

        figure(2);
            subplot(2,1,1);
                    plot(F,abs(H_IFIR)/max(abs(H_IFIR)),'b.-');  grid on;   hold on;
                    plot(F,abs(Href),'r.-');
                           xlim([0,0.012]);  
                           title('DTFT: modul(H)');    legend('H_I_F_I_R','H_r_e_f',0);
            subplot(2,1,2);
                    plot(F,angle(H_IFIR)/pi,'b.-');              grid on;   hold on;
                    plot(F,angle(Href)/pi,'r.-');
                           xlim([0,0.012]);  
                           title('DTFT: faza(H)/pi');  legend('H_I_F_I_R','H_r_e_f',0);
                           xlabel('F');
                        
% KONIEC PRZYKLADU 4.9.